function grad_f = CalculeGradient(f, x, epsilon)
  % CalculeGradient(f,x,epsilon)
  %	 
  %    calcule le gradient de f au point x par
  %    différences finies centrées, en utilisant un pas epsilon
	 
  if not(isvector(x))
     error('Le point x entré n’est pas un vecteur')
  end
	 
  % x est un vecteur de taille n
  n=length(x);

  % le gradient de f au point x a la même dimension que x
  grad_f = zeros(size(x));
  
  for i = 1:n
      
    % construction du vecteur i de la base canonique
    ei = zeros(size(x));
    ei(i) = 1;

    % calcul de la dérivée partielle selon la ième coordonnée,
    grad_f(i) = ( f(x+epsilon*ei) - f(x-epsilon*ei) ) / (2*epsilon);
  end
end
